SystemOrganization addCategory: #MicroEmpresarios!

TestCase subclass: #MicroEmp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MicroEmpresarios'!

!MicroEmp methodsFor: 'tests-support' stamp: 'Guidito 9/25/2012 21:46'!
personaModeradaConBajaTolerancia
	^ Persona moderada: 4! !

!MicroEmp methodsFor: 'tests' stamp: 'Guidito 10/2/2012 15:33'!
test01DadaGenteDistintaParaSubirseAunMicroApuradosSubenSiempre
	| unaPersonaApurada unMicro |
	unaPersonaApurada:= Persona apurada.
	unMicro:= Micro deVolumen:120 personasSentadas:10 personasParadas:10.
	unMicro puedeSubir: unaPersonaApurada.
	self assert:(unaPersonaApurada estaViajando).! !

!MicroEmp methodsFor: 'tests' stamp: 'Guidito 10/2/2012 16:09'!
test02DadaGenteDistintaParaSubirseAunMicroClaustrofobicosSubenSoloSiMicroEsMayorA120
	| unaPersonaClaustrofobica unMicro otroMicro |
	unaPersonaClaustrofobica:= Persona claustrofobica.
	unMicro:= Micro deVolumen:120 personasSentadas:10 personasParadas:10.
	unMicro puedeSubir:unaPersonaClaustrofobica.
	self deny:(unaPersonaClaustrofobica estaViajando).! !

!MicroEmp methodsFor: 'tests' stamp: 'Guidito 10/2/2012 16:10'!
test03DadaGenteDistintaParaSubirseAunMicroFiacasSubenSoloSiVanSentados
	| unaPersonaFiaca unMicro otroMicro |
	unaPersonaFiaca:= Persona fiaca.
	unMicro:= Micro deVolumen:120 personasSentadas:10 personasParadas:10.
	unMicro puedeSubir: unaPersonaFiaca.
	self assert:(unaPersonaFiaca estaViajando).! !

!MicroEmp methodsFor: 'tests' stamp: 'Guidito 10/2/2012 16:12'!
test04DadaGenteDistintaParaSubirseAunMicroModeradosSubenSoloSiHayTolerancia
	| unaPersonaModerada unMicro otroMicro |
	unaPersonaModerada := self personaModeradaConBajaTolerancia.
	unMicro := Micro deVolumen: 120 personasSentadas: 10 personasParadas: 10.
	unMicro puedeSubir:unaPersonaModerada.
	self assert: (unaPersonaModerada estaViajando).
	"Para excepciones:
	self should:[self error: 'explicacion de lo q paso'] raise:Error.
	"! !

!MicroEmp methodsFor: 'tests' stamp: 'Guidito 10/2/2012 16:49'!
test05DadaGenteDistintaParaSubirseAunMicroObsecuentesTomanMismaDecisionQueJefe
	| unaPersonaObsecuente unMicro otroMicro unJefe |
	unJefe:= Persona apurada.
	unaPersonaObsecuente := Persona obsecuente:unJefe.
	unMicro := Micro deVolumen: 120 personasSentadas: 10 personasParadas: 10.
	unMicro puedeSubir:unaPersonaObsecuente.
	self assert: (unaPersonaObsecuente estaViajando).! !

Object subclass: #Micro
	instanceVariableNames: 'perParadas perSentadas volumen asientosLibres espacioLibre paradosLibre'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MicroEmpresarios'!

!Micro class methodsFor: 'as yet unclassified' stamp: 'Guidito 9/25/2012 21:03'!
deVolumen: unVol personasSentadas: cantSent personasParadas: cantPar 
	 ^self new volumen: unVol sentadas: cantSent paradas: cantPar.
	! !

!Micro methodsFor: 'as yet unclassified' stamp: 'Guidito 9/25/2012 21:16'!
asientosLibres
	 ^asientosLibres.! !

!Micro methodsFor: 'as yet unclassified' stamp: 'Guidito 10/2/2012 16:15'!
espacioLibre
	^espacioLibre.! !

!Micro methodsFor: 'as yet unclassified' stamp: 'Guidito 9/25/2012 21:02'!
getVol
	^volumen.! !

!Micro methodsFor: 'as yet unclassified' stamp: 'Guidito 10/2/2012 15:14'!
hayEspacio
	^(espacioLibre>0)ifTrue:[true].! !

!Micro methodsFor: 'as yet unclassified' stamp: 'Guidito 10/2/2012 16:43'!
puedeSubir:unaPersona
	(unaPersona subi:self) ifTrue:[self subirPersona: unaPersona].
	
	! !

!Micro methodsFor: 'as yet unclassified' stamp: 'Guidito 10/2/2012 15:59'!
subirPersona:unaPersona
	unaPersona setEstado: true.! !

!Micro methodsFor: 'as yet unclassified' stamp: 'Guidito 9/25/2012 21:32'!
volumen: unVol sentadas: cantSent paradas: cantPar
	volumen:=unVol.
	perSentadas:=cantSent.
	perParadas:=cantPar.
	asientosLibres:=perSentadas.
	paradosLibre:=perParadas.
	espacioLibre:= asientosLibres + paradosLibre.! !

Object subclass: #Persona
	instanceVariableNames: 'tipo estado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MicroEmpresarios'!

Persona class
	instanceVariableNames: 'tipo'!

Persona class
	instanceVariableNames: 'tipo'!

!Persona class methodsFor: 'as yet unclassified' stamp: 'Guidito 9/25/2012 20:35'!
apurada
	 ^self con: Apurada new.! !

!Persona class methodsFor: 'as yet unclassified' stamp: 'Guidito 9/25/2012 20:35'!
claustrofobica
	 ^self con: Claustrofobica new.! !

!Persona class methodsFor: 'as yet unclassified' stamp: 'Guidito 9/25/2012 20:41'!
con: unTipo
	  ^self new inicializarCon: unTipo! !

!Persona class methodsFor: 'as yet unclassified' stamp: 'Guidito 9/25/2012 20:35'!
fiaca
	 ^self con: Fiaca new.! !

!Persona class methodsFor: 'as yet unclassified' stamp: 'Guidito 10/2/2012 15:29'!
moderada:unValor
	 ^self con: (Moderada new initialize: unValor).! !

!Persona class methodsFor: 'as yet unclassified' stamp: 'Guidito 10/2/2012 16:49'!
obsecuente:unJefe
	 ^self con: (Obsecuente new initialize: unJefe).! !

!Persona methodsFor: 'as yet unclassified' stamp: 'Guidito 10/2/2012 15:55'!
estaViajando
	^self getEstado.! !

!Persona methodsFor: 'as yet unclassified' stamp: 'Guidito 9/25/2012 20:38'!
getEstado
	^estado.! !

!Persona methodsFor: 'as yet unclassified' stamp: 'Guidito 9/25/2012 20:41'!
inicializarCon:  unTipo
	tipo:= unTipo.
	estado := false.! !

!Persona methodsFor: 'as yet unclassified' stamp: 'Guidito 9/25/2012 20:38'!
setEstado:comoEsta
	estado:=comoEsta.! !

!Persona methodsFor: 'as yet unclassified' stamp: 'Guidito 10/2/2012 16:45'!
subi: unMicro
	^(tipo subi: self a: unMicro)! !

!Persona methodsFor: 'as yet unclassified' stamp: 'Guidito 10/2/2012 16:44'!
subiria: unMicro
	^(tipo subi: self a: unMicro)! !

Object subclass: #TipoPersona
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MicroEmpresarios'!

TipoPersona subclass: #Apurada
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MicroEmpresarios'!

!Apurada methodsFor: 'as yet unclassified' stamp: 'Guidito 10/2/2012 16:44'!
subi:unaPersona a:unMicro
	(unMicro hayEspacio) ifTrue:[^true] ifFalse:[^false]! !

TipoPersona subclass: #Claustrofobica
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MicroEmpresarios'!

!Claustrofobica methodsFor: 'as yet unclassified' stamp: 'Guidito 10/2/2012 16:11'!
subi:unaPersona a:unMicro
	(unMicro getVol>120) ifTrue:[unMicro subirPersona:unaPersona].! !

TipoPersona subclass: #Fiaca
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MicroEmpresarios'!

!Fiaca methodsFor: 'as yet unclassified' stamp: 'Guidito 10/2/2012 16:11'!
subi:unaPersona a:unMicro
	(unMicro asientosLibres>0) ifTrue:[unMicro subirPersona: unaPersona].! !

TipoPersona subclass: #Moderada
	instanceVariableNames: 'tolerancia'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MicroEmpresarios'!

!Moderada methodsFor: 'as yet unclassified' stamp: 'Guidito 9/25/2012 21:29'!
initialize: unValor
	tolerancia:=unValor.! !

!Moderada methodsFor: 'as yet unclassified' stamp: 'Guidito 10/2/2012 16:14'!
subi:unaPersona a:unMicro
	(unMicro espacioLibre>0) ifTrue:[unMicro subirPersona: unaPersona].! !

TipoPersona subclass: #Obsecuente
	instanceVariableNames: 'jefe'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MicroEmpresarios'!

!Obsecuente methodsFor: 'as yet unclassified' stamp: 'Guidito 10/2/2012 16:17'!
initialize: unJefe
	jefe:=unJefe.! !

!Obsecuente methodsFor: 'as yet unclassified' stamp: 'Guidito 10/2/2012 16:47'!
subi: unaPersona a: unMicro
	(jefe subiria:unMicro) ifTrue:[unMicro puedeSubir: unaPersona].! !
